您的位置:首页 > 其它

hdu 3613 Best Reward (扩展KMP)

2016-10-17 15:25 597 查看
Problem Description

After an uphill battle, General Li won a great victory. Now the head of state decide to reward him with honor and treasures for his great exploit. 

One of these treasures is a necklace made up of 26 different kinds of gemstones, and the length of the necklace is n. (That is to say: n gemstones are stringed together to constitute this necklace, and each of these gemstones belongs to only one of the 26 kinds.) 

In accordance with the classical view, a necklace is valuable if and only if it is a palindrome - the necklace looks the same in either direction. However, the necklace we mentioned above may not a palindrome at the beginning. So the head of state decide to
cut the necklace into two part, and then give both of them to General Li. 

All gemstones of the same kind has the same value (may be positive or negative because of their quality - some kinds are beautiful while some others may looks just like normal stones). A necklace that is palindrom has value equal to the sum of its gemstones'
value. while a necklace that is not palindrom has value zero. 

Now the problem is: how to cut the given necklace so that the sum of the two necklaces's value is greatest. Output this value. 

 

Input

The first line of input is a single integer T (1 ≤ T ≤ 10) - the number of test cases. The description of these test cases follows. 

For each test case, the first line is 26 integers: v1, v2, ..., v26 (-100 ≤ vi ≤ 100, 1 ≤ i ≤ 26), represent the value of gemstones of each kind. 

The second line of each test case is a string made up of charactor 'a' to 'z'. representing the necklace. Different charactor representing different kinds of gemstones, and the value of 'a' is v1, the value of 'b' is v2, ..., and so on.
The length of the string is no more than 500000. 

 

Output

Output a single Integer: the maximum value General Li can get from the necklace.

 

Sample Input

2
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
aba
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
acacac

 

Sample Output

1
6

 

Source

2010 ACM-ICPC Multi-University Training Contest(18)——Host
by TJU

 

Recommend

lcy   |   We have carefully selected several similar problems for you:  3618 3620 3614 3615 3616 

题意:首先输入n表示有n个测试,接着下一行有26个数分别表示a,b,c....z的价值,然后输入一行字符串,求将该字符串二分后的最大价值,二分后的字串如果是回文串则价值为字符价值之和,否则价值为0

思路:

本题难度在于如何将原串二分后判断前缀是否是回文和后缀是否是回文串 

则可以将原串反转得s2,然后用原串s1去匹配s2,最终s1匹配到的位置就是s1的最大前缀回文串 

同理用s2去匹配s1得到s2的最大前缀回文串,即s1得最大后悔回文串 

然后根据next[k]的特性,next[k]跳转到的位置就是下一个前缀回文串(0~k和x~len相同,而x~len又是0~k反转得到的,所以0~k是回文串) 

直到k=0,将所有前缀回文串和后缀回文串标记,然后对原串线性扫描求出最大值即可;
代码:

#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int N=500005;
const int maxn=0xffffff;
int a[26],sum
;
int per
,pos
;//用来记录前缀回文串和后缀回文串
int nex
;
void getnext(char *c,int len)
{
int i=0,j=-1;
nex[0]=-1;
while(i<len)
{
if(j==-1||c[i]==c[j])
nex[++i]=++j;
else
j=nex[j];
}
}
int kmp(char *c1,char *c2,int len)
{
int j=0;
for(int i=0;i<len;i++)
{
if(c1[i]==c2[j])
{
j++;
if(j==len)
{
return j;
}
continue;
}
if(j==0)
continue;
j=nex[j];
i--;
}
return j;
}
int main()
{
int k,t;
char c1
,c2
;
scanf("%d",&t);
while(t--)
{
for(int i=0;i<26;i++)
scanf("%d",&a[i]);
scanf("%s",c1);
int len=strlen(c1);
sum[0]=0;
for(int i=0;i<len;i++)
{
c2[i]=c1[len-1-i];
sum[i+1]=sum[i]+a[c1[i]-'a'];
}
getnext(c1,len);
k=kmp(c2,c1,len);  //最大前缀回文串
while(k)
{
per[k]=t+1;k=nex[k];  //记录
}
getnext(c2,len);
k=kmp(c1,c2,len);  //最大后缀回文串
while(k)
{
pos[k]=t+1;k=nex[k];
}
int num=0;
int maxx=-maxn;
for(int i=1;i<len;i++)
{
if(per[i]==t+1)
num+=sum[i];
if(pos[len-i]==t+1)
num+=sum[len]-sum[i];
if(maxx<num)
maxx=num;
num=0;
}
printf("%d\n",maxx);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: